#pragma inline
#include "lfn.h"
#include "asmrules.h"

HFIND	find_first_file(
		BYTE searchattrs, 
		BYTE mustmatchattrs,
		WORD datetype, 
		const char * wildcard,
		struct finddata *fd,  
		BYTE * unicode)  	
{
	WORD	code;
	HFIND	handle;
asm	push	ds
asm	push 	si
asm	push 	di
asm	stc
asm	mov 	ax, LONG_FIND_FIRST
asm	mov 	cl, [searchattrs]
asm	mov 	ch, [mustmatchattrs]
asm	mov 	si, [datetype]
asm	LDS_	dx, wildcard
asm	LES_	di, fd  	
asm	int 	21h
asm	jc 	error
asm	LDS_ 	si, unicode
asm	mov     [si], cx
asm	mov 	[handle], ax
asm	xor 	ax, ax
error:
asm	pop 	di
asm	pop 	si	
asm	pop 	ds
asm	mov 	[code], ax
        error_code("find first file", code);
	return handle; 
}
