#include "lfn.h"

SEEKPOS	get_file_size(
		const char * filename)
{
	SEEKPOS size = 0;
	WORD old_errno = 0;
	WORD action = LONG_CREATE_FILE_OPEN;
	HFILE handle = create_file(filename, OPEN_ACCESS_READONLY,
			FILE_ATTR_ALL, &action, 0);
	if (__lfnerrno != 0 || action != LONG_CREATE_FILE_OPENED || handle == 0)
		return 0;
	size = lseek(handle, 0, LSEEK_END_FILE_POS);
	if (__lfnerrno != 0) {
		size = 0;
		old_errno = __lfnerrno;
	}
	close_file(handle);
	__lfnerrno = old_errno;
	return size;
}
