#pragma inline
#include "lfn.h"
#include "asmrules.h"

void	generate_short_filename(
		const char *longname, 
		char *shortname,
		BYTE format, 
		BYTE charset)
{
	WORD	code;
asm	push	ds
asm	push 	di
asm	push 	si
asm	stc
asm	mov 	ax, LONG_GENERATE_SHORT_NAME
asm	mov 	dh, [format]
asm	mov 	dl, [charset]
asm	LDS_	si, longname
asm	LES_	di, shortname      	
asm	int 	21h
asm	pop 	si
asm	pop 	di
asm	pop 	ds
asm	jc 	error
asm	xor 	ax, ax
error:
asm	mov 	[code], ax
        error_code("generate short filename", code);
	return;
}
