#pragma inline
#include "lfn.h"
#include "asmrules.h"

void	get_set_file_attributes(
		const char * name,
		BYTE action, 
		union fileattrs *fa)
{
	WORD	code;
	WORD	msecs;
asm	push 	ds
asm	push 	si
asm	push 	di
asm	mov 	bl, [action]	
asm	LDS_	si, fa
asm	cmp	bl,  LONG_GET_SET_FILE_ATTR_SET_ATTR
asm	jne 	_1
/*asm	mov 	cx, [si].attributes	*/
asm	mov 	cx, [si]
asm	jmp 	_4
_1:
asm	cmp	bl, LONG_GET_SET_FILE_ATTR_SET_WRITE_DATE
asm	jne	 _2
asm	mov 	di, [si].dt.d		
asm	mov 	cx, [si].dt.t		
asm	jmp 	_4
_2:
asm	cmp	bl, LONG_GET_SET_FILE_ATTR_SET_ACCESS_DATE
asm	jne 	_3
asm	mov 	di, [si].dt.d		
asm	mov 	cx, 0		
asm	jmp 	_4
_3:
asm	cmp	bl, LONG_GET_SET_FILE_ATTR_SET_CREATION_DATE
asm	jne 	_4
asm	mov 	di, [si].dt.d		
asm	mov 	cx, [si].dt.t		
asm	mov 	si, [si].dt.milisecs		
_4:
asm	LDS_ 	dx, name	
asm	mov 	ax, LONG_GET_SET_FILE_ATTR
asm	stc
asm	int 	21h
asm	jc 	error

asm	mov	[msecs], si
asm	LDS_	si, fa

asm	mov 	bl, [action]	
asm	cmp	bl,  LONG_GET_SET_FILE_ATTR_GET_ATTR
asm	jne 	_11
/*asm	mov 	[si].attributes, cx		*/
asm	mov 	[si], cx		
asm	jmp 	_15
_11:
asm	cmp	bl, LONG_GET_SET_FILE_ATTR_GET_WRITE_DATE
asm	jne 	_12
asm	mov 	[si].dt.d, di		
asm	mov 	[si].dt.t, cx		
asm	jmp 	_15
_12:
asm	cmp	bl, LONG_GET_SET_FILE_ATTR_GET_ACCESS_DATE
asm	jne 	_13
asm	mov 	[si].dt.d, di		
asm	jmp 	_15
_13:
asm	cmp	bl, LONG_GET_SET_FILE_ATTR_GET_CREATION_DATE
asm	jne 	_14
asm	mov 	[si].dt.d, di		
asm	mov 	[si].dt.t, cx		
asm	mov	cx, [msecs]
asm	mov 	[si].dt.milisecs, cx
asm	jmp 	_15
_14:
asm	cmp	bl, LONG_GET_SET_FILE_ATTR_DRIVE_PHYS_SIZE 	
asm	jne 	error
asm	mov 	WORD PTR [si].size,   ax
asm	mov 	WORD PTR [si].size+2, dx
_15:
asm	xor 	ax, ax
error:
asm	pop 	di
asm	pop 	si
asm	pop	ds
asm	mov 	[code], ax
        error_code("get set file attributes", code);
	return;
} 		
