#pragma inline
#include "lfn.h"
#include "asmrules.h"

void	write_file(
		HFILE handle, 
		const char *buf, 
		WORD bufsize, 
		WORD * written) 	
{
	WORD	code;
asm	push 	ds
asm	stc
asm	mov 	ah, WRITE_FILE
asm	mov 	bx, [handle]
asm	mov	cx, [bufsize]
asm	LDS_	dx, buf
asm	int 	21h
asm	jc 	error
asm	LDS_	si, written
asm	mov	[si], ax
asm	xor 	ax, ax
error:
asm	pop	ds
asm	mov [code], ax
        error_code("write file", code);
	return;
}
