#include <stdio.h>
#include <dos.h>
#include "lfn.h"
#include <string.h>

int main(void)
{
	struct find_t ffblk;
	int done;
	char attrs[8];
	char date[32];
//	printf("Directory listing of *.*\n");
//	done = _dos_findfirst("*.*",FILE_ATTR_ALL,&ffblk);
	printf("Directory listing of c:\\djgpp\\src in directory c:\\djgpp\\src\\libc\\stubs\n");
	done = _dos_findfirst("c:\\djgpp\\src",FILE_ATTR_ALL,&ffblk);

	while (!done) {
		date[0] = attrs[0]='\0';		
		sprintf(date,"%02u/%02u/%4u %02u:%02u:%02u"
			,GET_DATE_MONTH(ffblk.wr_date)
			,GET_DATE_DAY(ffblk.wr_date)
			,GET_DATE_YEAR(ffblk.wr_date)
			,GET_TIME_HOURS(ffblk.wr_time)
			,GET_TIME_MINUTES(ffblk.wr_time)
			,GET_TIME_SECONDS(ffblk.wr_time)
			);
		if (ffblk.attrib & FILE_ATTR_READONLY      ) strcat(attrs,"R"); else strcat(attrs,"_");
		if (ffblk.attrib & FILE_ATTR_HIDDEN        ) strcat(attrs,"H"); else strcat(attrs,"_");
		if (ffblk.attrib & FILE_ATTR_SYSTEM        ) strcat(attrs,"S"); else strcat(attrs,"_");
		if (ffblk.attrib & FILE_ATTR_VOLUME_LABEL  ) strcat(attrs,"V"); else strcat(attrs,"_");
		if (ffblk.attrib & FILE_ATTR_DIRECTORY     ) strcat(attrs,"D"); else strcat(attrs,"_");
		if (ffblk.attrib & FILE_ATTR_ARCHIVE       ) strcat(attrs,"A"); else strcat(attrs,"_");

		printf("%s\t\t%12lu %-12s %-8s\n", date, ffblk.size, ffblk.name, attrs);
		done = _dos_findnext(&ffblk);
	}
	return 0;
}

