#include "lfn.h"
#include <stdio.h>

#define DIR_NAME	"directory1234567890"
#define FILE_NAME	"directory1234567890\\filename123456789"
#define FILE_NAME2	"h:\\filename123456789"
#define	DRIVE_NUM	8

void 	truename_tests(void)
{
	char buf[260];

	puts("begin tests ...");

//	set_current_directory("h:\\");
//	puts("dir changed");

	truename(FILE_NAME, buf, LONG_TRUENAME_CLASS_CANONICAL , LONG_TRUENAME_NO_SUBST);
	puts(buf);
	buf[0] = '\0';

	truename(FILE_NAME, buf, LONG_TRUENAME_CLASS_CANONICAL , LONG_TRUENAME_SUBST);
	puts(buf);
	buf[0] = '\0';

	truename(FILE_NAME, buf, LONG_TRUENAME_CLASS_SHORT, LONG_TRUENAME_NO_SUBST);
	puts(buf);
	buf[0] = '\0';

	truename(FILE_NAME, buf, LONG_TRUENAME_CLASS_SHORT, LONG_TRUENAME_SUBST);
	puts(buf);
	buf[0] = '\0';

	truename(FILE_NAME, buf, LONG_TRUENAME_CLASS_LONG, LONG_TRUENAME_NO_SUBST);
	puts(buf);
	buf[0] = '\0';

	truename(FILE_NAME, buf, LONG_TRUENAME_CLASS_LONG, LONG_TRUENAME_SUBST);
	puts(buf);
	buf[0] = '\0';
	puts("---------");

	truename(FILE_NAME2, buf, LONG_TRUENAME_CLASS_CANONICAL , LONG_TRUENAME_NO_SUBST);
	puts(buf);
	buf[0] = '\0';

	truename(FILE_NAME2, buf, LONG_TRUENAME_CLASS_CANONICAL , LONG_TRUENAME_SUBST);
	puts(buf);
	buf[0] = '\0';

	truename(FILE_NAME2, buf, LONG_TRUENAME_CLASS_SHORT, LONG_TRUENAME_NO_SUBST);
	puts(buf);
	buf[0] = '\0';

	truename(FILE_NAME2, buf, LONG_TRUENAME_CLASS_SHORT, LONG_TRUENAME_SUBST);
	puts(buf);
	buf[0] = '\0';

	truename(FILE_NAME2, buf, LONG_TRUENAME_CLASS_LONG, LONG_TRUENAME_NO_SUBST);
	puts(buf);
	buf[0] = '\0';

	truename(FILE_NAME2, buf, LONG_TRUENAME_CLASS_LONG, LONG_TRUENAME_SUBST);
	puts(buf);
	buf[0] = '\0';

	puts("---------");
	puts("End tests ...");
}

int main()
{
	char buf[260];
	buf[0]='\0';
	puts("#0");

	puts("#1");
	subst(DIR_NAME, DRIVE_NUM, LONG_SUBST_CREATE );
	if (__lfnerrno != 0)
		return 1;
	puts("#2");
	subst(buf, DRIVE_NUM, LONG_SUBST_QUERY );
	if (__lfnerrno != 0) 
		return 1;

	printf("substed drive %c is %s\n", 'A'+DRIVE_NUM-1, buf);	
	puts("#3");
	truename_tests();
	subst("", DRIVE_NUM, LONG_SUBST_TERMINATE );	

	puts("#4");
	return 0;
}

